Hex Artifact Content

Artifact 3e68dc7fb5a8b346009a99b532640e67325bff0e:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09  n download() {..
0130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
0140: 61 72 63 68 69 76 65 7d 22 20 5d 3b 20 74 68 65  archive}" ]; the
0150: 6e 0a 09 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09  n...# Download..
0160: 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 09 72 6d  .## Cleanup...rm
0170: 20 2d 66 20 73 72 63 2e 6e 65 77 0a 0a 09 09 23   -f src.new....#
0180: 23 20 46 65 74 63 68 20 66 69 6c 65 0a 09 09 77  # Fetch file...w
0190: 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22  get -O src.new "
01a0: 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20  ${url}" || exit 
01b0: 31 0a 0a 09 09 23 23 20 56 65 72 69 66 79 20 73  1....## Verify s
01c0: 69 67 6e 61 74 75 72 65 0a 09 09 73 72 63 5f 73  ignature...src_s
01d0: 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73 6c  ha256="$(openssl
01e0: 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65 77   sha256 'src.new
01f0: 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d 20  ' | sed 's@^.*= 
0200: 40 40 27 29 22 0a 09 09 69 66 20 5b 20 22 24 7b  @@')"...if [ "${
0210: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0220: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0230: 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 53 48 41  hen....echo "SHA
0240: 32 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44  256 mismatch:  D
0250: 6f 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63  ownloaded: ${src
0260: 5f 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65  _sha256} != Expe
0270: 63 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22  cted: ${sha256}"
0280: 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20 31 0a   >&2.....exit 1.
0290: 09 09 66 69 0a 0a 09 09 23 23 20 4d 6f 76 65 20  ..fi....## Move 
02a0: 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61 63 65 0a  file into place.
02b0: 09 09 6d 76 20 73 72 63 2e 6e 65 77 20 22 24 7b  ..mv src.new "${
02c0: 70 6b 67 61 72 63 68 69 76 65 7d 22 0a 09 66 69  pkgarchive}"..fi
02d0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74  .}..function ext
02e0: 72 61 63 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ract() {..local 
02f0: 64 65 63 6f 6d 70 72 65 73 73 0a 0a 09 23 20 44  decompress...# D
0300: 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76  ecompress archiv
0310: 65 0a 09 23 23 20 44 65 74 65 72 6d 69 6e 65 20  e..## Determine 
0320: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0330: 09 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69  .case "${url}" i
0340: 6e 0a 09 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74  n...*.tar.xz|*.t
0350: 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29  ar.xz'?'*|*.txz)
0360: 0a 09 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  ....decompress='
0370: 78 7a 27 0a 09 09 09 3b 3b 0a 09 09 2a 2e 74 61  xz'....;;...*.ta
0380: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0390: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 09 64 65 63 6f  *|*.tgz)....deco
03a0: 6d 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09  mpress='gzip'...
03b0: 09 3b 3b 0a 09 09 2a 2e 74 61 72 2e 62 7a 32 7c  .;;...*.tar.bz2|
03c0: 2a 2e 74 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e  *.tar.bz2'?'*|*.
03d0: 74 62 7a 32 29 0a 09 09 09 64 65 63 6f 6d 70 72  tbz2)....decompr
03e0: 65 73 73 3d 27 62 7a 69 70 32 27 0a 09 09 09 3b  ess='bzip2'....;
03f0: 3b 0a 09 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70 27  ;...*.zip|*.zip'
0400: 3f 27 2a 29 0a 09 09 09 64 65 63 6f 6d 70 72 65  ?'*)....decompre
0410: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 09 3b 3b  ss='unzip'....;;
0420: 0a 09 09 2a 29 0a 09 09 09 65 63 68 6f 20 22 55  ...*)....echo "U
0430: 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69  nknown compressi
0440: 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c  on method: ${url
0450: 7d 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  }" >&2.....exit 
0460: 31 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09  1....;;..esac...
0470: 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65 73 73  ## Do decompress
0480: 69 6f 6e 0a 09 63 61 73 65 20 22 24 7b 64 65 63  ion..case "${dec
0490: 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 09 75  ompress}" in...u
04a0: 6e 7a 69 70 29 0a 09 09 09 75 6e 7a 69 70 20 22  nzip)....unzip "
04b0: 24 7b 70 6b 67 61 72 63 68 69 76 65 7d 22 20 7c  ${pkgarchive}" |
04c0: 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74 6f  | die 'Unable to
04d0: 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63 68   uncompress arch
04e0: 69 76 65 27 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a  ive'....;;...*).
04f0: 09 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0500: 7d 22 20 2d 64 63 20 22 24 7b 70 6b 67 61 72 63  }" -dc "${pkgarc
0510: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
0520: 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c   - || die 'Unabl
0530: 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20  e to uncompress 
0540: 61 72 63 68 69 76 65 27 0a 09 09 09 3b 3b 0a 09  archive'....;;..
0550: 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  esac.}..function
0560: 20 61 70 70 6c 79 5f 70 61 74 63 68 65 73 28 29   apply_patches()
0570: 20 7b 0a 09 6c 6f 63 61 6c 20 70 61 74 63 68 0a   {..local patch.
0580: 0a 09 66 6f 72 20 70 61 74 63 68 20 69 6e 20 22  ..for patch in "
0590: 24 7b 70 6b 67 64 69 72 7d 2f 70 61 74 63 68 65  ${pkgdir}/patche
05a0: 73 22 2f 2a 3b 20 64 6f 0a 09 09 69 66 20 5b 20  s"/*; do...if [ 
05b0: 21 20 2d 65 20 22 24 7b 70 61 74 63 68 7d 22 20  ! -e "${patch}" 
05c0: 5d 3b 20 74 68 65 6e 0a 09 09 09 63 6f 6e 74 69  ]; then....conti
05d0: 6e 75 65 0a 09 09 66 69 0a 0a 09 09 63 61 73 65  nue...fi....case
05e0: 20 22 24 7b 70 61 74 63 68 7d 22 20 69 6e 0a 09   "${patch}" in..
05f0: 09 09 2a 2e 64 69 66 66 7c 2a 2e 70 61 74 63 68  ..*.diff|*.patch
0600: 29 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 29 0a 09  ).....;;....*)..
0610: 09 09 09 63 6f 6e 74 69 6e 75 65 0a 09 09 09 09  ...continue.....
0620: 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 69 66 20  ;;...esac....if 
0630: 5b 20 2d 65 20 22 24 7b 70 61 74 63 68 7d 2e 73  [ -e "${patch}.s
0640: 68 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 69 66  h" ]; then....if
0650: 20 21 20 73 68 20 22 24 7b 70 61 74 63 68 7d 2e   ! sh "${patch}.
0660: 73 68 22 3b 20 74 68 65 6e 0a 09 09 09 09 63 6f  sh"; then.....co
0670: 6e 74 69 6e 75 65 0a 09 09 09 66 69 0a 09 09 66  ntinue....fi...f
0680: 69 0a 0a 09 09 70 61 74 63 68 20 2d 70 31 20 3c  i....patch -p1 <
0690: 20 22 24 7b 70 61 74 63 68 7d 22 0a 09 64 6f 6e   "${patch}"..don
06a0: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 76 65  e.}..function ve
06b0: 72 69 66 79 52 65 71 75 69 72 65 64 50 61 63 6b  rifyRequiredPack
06c0: 61 67 65 73 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ages() {..local 
06d0: 70 6b 67 20 70 6b 67 64 6f 6d 61 69 6e 20 70 6b  pkg pkgdomain pk
06e0: 67 76 65 72 73 69 6f 6e 0a 09 6c 6f 63 61 6c 20  gversion..local 
06f0: 70 6b 67 64 69 72 20 70 6b 67 63 6f 6e 66 69 67  pkgdir pkgconfig
0700: 64 69 72 20 70 6b 67 66 6f 75 6e 64 0a 0a 09 66  dir pkgfound...f
0710: 6f 72 20 70 6b 67 20 69 6e 20 22 24 7b 72 65 71  or pkg in "${req
0720: 75 69 72 65 5b 40 5d 7d 22 3b 20 64 6f 0a 09 09  uire[@]}"; do...
0730: 70 6b 67 64 6f 6d 61 69 6e 3d 27 27 0a 09 09 70  pkgdomain=''...p
0740: 6b 67 76 65 72 73 69 6f 6e 3d 27 27 0a 09 09 70  kgversion=''...p
0750: 6b 67 63 68 61 6e 67 65 73 3d 28 43 46 4c 41 47  kgchanges=(CFLAG
0760: 53 20 4c 44 46 4c 41 47 53 20 50 41 54 48 20 50  S LDFLAGS PATH P
0770: 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 29 0a  KG_CONFIG_PATH).
0780: 0a 09 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22  ...case "${pkg}"
0790: 20 69 6e 0a 09 09 09 2a 3a 2a 29 0a 09 09 09 09   in....*:*).....
07a0: 70 6b 67 63 68 61 6e 67 65 73 3d 28 24 28 65 63  pkgchanges=($(ec
07b0: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
07c0: 74 20 2d 66 20 32 20 2d 64 20 27 3a 27 29 29 0a  t -f 2 -d ':')).
07d0: 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f 20  ....pkg="$(echo 
07e0: 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d  "${pkg}" | cut -
07f0: 66 20 31 20 2d 64 20 27 3a 27 29 22 0a 09 09 09  f 1 -d ':')"....
0800: 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 63 61  .;;...esac....ca
0810: 73 65 20 22 24 7b 70 6b 67 7d 22 20 69 6e 0a 09  se "${pkg}" in..
0820: 09 09 2a 2f 2a 40 2a 29 0a 09 09 09 09 70 6b 67  ..*/*@*).....pkg
0830: 64 6f 6d 61 69 6e 3d 22 24 28 65 63 68 6f 20 22  domain="$(echo "
0840: 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20 2d 66  ${pkg}" | cut -f
0850: 20 32 20 2d 64 20 27 40 27 29 22 0a 09 09 09 09   2 -d '@')".....
0860: 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24 28 65 63  pkgversion="$(ec
0870: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
0880: 74 20 2d 66 20 32 20 2d 64 20 27 2f 27 20 7c 20  t -f 2 -d '/' | 
0890: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 40 27 29  cut -f 1 -d '@')
08a0: 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68  ".....pkg="$(ech
08b0: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
08c0: 20 2d 66 20 31 20 2d 64 20 27 2f 27 29 22 0a 09   -f 1 -d '/')"..
08d0: 09 09 09 3b 3b 0a 09 09 09 2a 2f 2a 29 0a 09 09  ...;;....*/*)...
08e0: 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24 28  ..pkgversion="$(
08f0: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
0900: 63 75 74 20 2d 66 20 32 20 2d 64 20 27 2f 27 29  cut -f 2 -d '/')
0910: 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68  ".....pkg="$(ech
0920: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
0930: 20 2d 66 20 31 20 2d 64 20 27 2f 27 29 22 0a 09   -f 1 -d '/')"..
0940: 09 09 09 3b 3b 0a 09 09 09 2a 40 2a 29 0a 09 09  ...;;....*@*)...
0950: 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28 65  ..pkgdomain="$(e
0960: 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63  cho "${pkg}" | c
0970: 75 74 20 2d 66 20 32 20 2d 64 20 27 40 27 29 22  ut -f 2 -d '@')"
0980: 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63 68 6f  .....pkg="$(echo
0990: 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74 20   "${pkg}" | cut 
09a0: 2d 66 20 31 20 2d 64 20 27 40 27 29 22 0a 09 09  -f 1 -d '@')"...
09b0: 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09 69  ..;;...esac....i
09c0: 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67 64 6f 6d  f [ -z "${pkgdom
09d0: 61 69 6e 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  ain}" ]; then...
09e0: 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 7b 64 6f  .pkgdomain="${do
09f0: 6d 61 69 6e 7d 22 0a 09 09 66 69 0a 0a 09 09 70  main}"...fi....p
0a00: 6b 67 66 6f 75 6e 64 3d 27 30 27 0a 09 09 66 6f  kgfound='0'...fo
0a10: 72 20 70 6b 67 64 69 72 20 69 6e 20 22 2f 6f 70  r pkgdir in "/op
0a20: 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67 64 6f 6d  t/appfs/${pkgdom
0a30: 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70 6c 61 74  ain}/${pkg}/plat
0a40: 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65 72 73 69  form"/${pkgversi
0a50: 6f 6e 3a 2d 6c 61 74 65 73 74 7d 20 22 2f 6f 70  on:-latest} "/op
0a60: 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67 64 6f 6d  t/appfs/${pkgdom
0a70: 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70 6c 61 74  ain}/${pkg}/plat
0a80: 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65 72 73 69  form"/${pkgversi
0a90: 6f 6e 3a 2d 2a 7d 3b 20 64 6f 0a 09 09 09 70 6b  on:-*}; do....pk
0aa0: 67 63 6f 6e 66 69 67 64 69 72 3d 22 24 7b 70 6b  gconfigdir="${pk
0ab0: 67 64 69 72 7d 2f 6c 69 62 2f 70 6b 67 63 6f 6e  gdir}/lib/pkgcon
0ac0: 66 69 67 22 0a 0a 09 09 09 69 66 20 5b 20 21 20  fig".....if [ ! 
0ad0: 2d 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20 5d  -d "${pkgdir}" ]
0ae0: 3b 20 74 68 65 6e 0a 09 09 09 09 63 6f 6e 74 69  ; then.....conti
0af0: 6e 75 65 0a 09 09 09 66 69 0a 0a 09 09 09 23 20  nue....fi.....# 
0b00: 49 66 20 74 68 65 20 70 61 63 6b 61 67 65 20 76  If the package v
0b10: 65 72 73 69 6f 6e 20 77 61 73 20 75 6e 73 70 65  ersion was unspe
0b20: 63 69 66 69 65 64 2c 20 66 75 6c 6c 79 20 72 65  cified, fully re
0b30: 73 6f 6c 76 65 0a 09 09 09 23 20 74 68 65 20 64  solve....# the d
0b40: 69 72 65 63 74 6f 72 79 20 74 68 61 74 20 77 65  irectory that we
0b50: 20 66 6f 75 6e 64 0a 09 09 09 69 66 20 5b 20 2d   found....if [ -
0b60: 7a 20 22 24 7b 70 6b 67 76 65 72 73 69 6f 6e 7d  z "${pkgversion}
0b70: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 09 70 6b  " ]; then.....pk
0b80: 67 64 69 72 3d 22 24 28 72 65 61 64 6c 69 6e 6b  gdir="$(readlink
0b90: 20 2d 66 20 22 24 7b 70 6b 67 64 69 72 7d 22 29   -f "${pkgdir}")
0ba0: 22 0a 09 09 09 66 69 0a 0a 09 09 09 70 6b 67 66  "....fi.....pkgf
0bb0: 6f 75 6e 64 3d 27 31 27 0a 0a 09 09 09 66 6f 72  ound='1'.....for
0bc0: 20 70 6b 67 63 68 61 6e 67 65 20 69 6e 20 22 24   pkgchange in "$
0bd0: 7b 70 6b 67 63 68 61 6e 67 65 73 5b 40 5d 7d 22  {pkgchanges[@]}"
0be0: 3b 20 64 6f 0a 09 09 09 09 63 61 73 65 20 22 24  ; do.....case "$
0bf0: 7b 70 6b 67 63 68 61 6e 67 65 7d 22 20 69 6e 0a  {pkgchange}" in.
0c00: 09 09 09 09 09 43 46 4c 41 47 53 29 0a 09 09 09  .....CFLAGS)....
0c10: 09 09 09 43 46 4c 41 47 53 3d 22 24 7b 43 46 4c  ...CFLAGS="${CFL
0c20: 41 47 53 7d 20 2d 69 73 79 73 74 65 6d 20 24 7b  AGS} -isystem ${
0c30: 70 6b 67 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22  pkgdir}/include"
0c40: 0a 09 09 09 09 09 09 43 50 50 46 4c 41 47 53 3d  .......CPPFLAGS=
0c50: 22 24 7b 43 50 50 46 4c 41 47 53 7d 20 2d 69 73  "${CPPFLAGS} -is
0c60: 79 73 74 65 6d 20 24 7b 70 6b 67 64 69 72 7d 2f  ystem ${pkgdir}/
0c70: 69 6e 63 6c 75 64 65 22 0a 09 09 09 09 09 09 65  include".......e
0c80: 78 70 6f 72 74 20 43 46 4c 41 47 53 20 43 50 50  xport CFLAGS CPP
0c90: 46 4c 41 47 53 0a 09 09 09 09 09 09 3b 3b 0a 09  FLAGS.......;;..
0ca0: 09 09 09 09 4c 44 46 4c 41 47 53 29 0a 09 09 09  ....LDFLAGS)....
0cb0: 09 09 09 4c 44 46 4c 41 47 53 3d 22 24 7b 4c 44  ...LDFLAGS="${LD
0cc0: 46 4c 41 47 53 7d 20 2d 4c 24 7b 70 6b 67 64 69  FLAGS} -L${pkgdi
0cd0: 72 7d 2f 6c 69 62 20 2d 57 6c 2c 2d 72 70 61 74  r}/lib -Wl,-rpat
0ce0: 68 2c 24 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 22  h,${pkgdir}/lib"
0cf0: 0a 09 09 09 09 09 09 65 78 70 6f 72 74 20 4c 44  .......export LD
0d00: 46 4c 41 47 53 0a 09 09 09 09 09 09 3b 3b 0a 09  FLAGS.......;;..
0d10: 09 09 09 09 50 41 54 48 29 0a 09 09 09 09 09 09  ....PATH).......
0d20: 50 41 54 48 3d 22 24 7b 50 41 54 48 7d 3a 24 7b  PATH="${PATH}:${
0d30: 70 6b 67 64 69 72 7d 2f 62 69 6e 22 0a 09 09 09  pkgdir}/bin"....
0d40: 09 09 09 65 78 70 6f 72 74 20 50 41 54 48 0a 09  ...export PATH..
0d50: 09 09 09 09 09 3b 3b 0a 09 09 09 09 09 50 4b 47  .....;;......PKG
0d60: 5f 43 4f 4e 46 49 47 5f 50 41 54 48 29 0a 09 09  _CONFIG_PATH)...
0d70: 09 09 09 09 69 66 20 5b 20 2d 64 20 22 24 7b 70  ....if [ -d "${p
0d80: 6b 67 63 6f 6e 66 69 67 64 69 72 7d 22 20 5d 3b  kgconfigdir}" ];
0d90: 20 74 68 65 6e 0a 09 09 09 09 09 09 09 50 4b 47   then........PKG
0da0: 5f 43 4f 4e 46 49 47 5f 50 41 54 48 3d 22 24 7b  _CONFIG_PATH="${
0db0: 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 7d  PKG_CONFIG_PATH}
0dc0: 3a 24 7b 70 6b 67 63 6f 6e 66 69 67 64 69 72 7d  :${pkgconfigdir}
0dd0: 22 0a 09 09 09 09 09 09 09 65 78 70 6f 72 74 20  "........export 
0de0: 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54 48 0a  PKG_CONFIG_PATH.
0df0: 09 09 09 09 09 09 66 69 0a 09 09 09 09 09 09 3b  ......fi.......;
0e00: 3b 0a 09 09 09 09 65 73 61 63 0a 09 09 09 64 6f  ;.....esac....do
0e10: 6e 65 0a 0a 09 09 09 62 72 65 61 6b 0a 09 09 64  ne.....break...d
0e20: 6f 6e 65 0a 0a 09 09 69 66 20 5b 20 22 24 7b 70  one....if [ "${p
0e30: 6b 67 66 6f 75 6e 64 7d 22 20 3d 20 27 30 27 20  kgfound}" = '0' 
0e40: 5d 3b 20 74 68 65 6e 0a 09 09 09 64 69 65 20 22  ]; then....die "
0e50: 50 61 63 6b 61 67 65 20 24 7b 70 6b 67 7d 2f 24  Package ${pkg}/$
0e60: 7b 70 6b 67 76 65 72 73 69 6f 6e 3a 2d 2a 7d 40  {pkgversion:-*}@
0e70: 24 7b 70 6b 67 64 6f 6d 61 69 6e 7d 20 6e 6f 74  ${pkgdomain} not
0e80: 20 66 6f 75 6e 64 2e 22 0a 09 09 66 69 0a 09 64   found."...fi..d
0e90: 6f 6e 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20  one.}..function 
0ea0: 76 65 72 69 66 79 50 72 65 72 65 71 75 69 73 69  verifyPrerequisi
0eb0: 74 65 73 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  tes() {..:.}..fu
0ec0: 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e 65  nction determine
0ed0: 4f 73 41 72 63 68 28 29 20 7b 0a 09 6f 73 3d 22  OsArch() {..os="
0ee0: 24 28 75 6e 61 6d 65 20 2d 73 20 7c 20 64 64 20  $(uname -s | dd 
0ef0: 63 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65  conv=lcase 2>/de
0f00: 76 2f 6e 75 6c 6c 29 22 0a 09 61 72 63 68 3d 22  v/null)"..arch="
0f10: 24 28 75 6e 61 6d 65 20 2d 6d 20 7c 20 64 64 20  $(uname -m | dd 
0f20: 63 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65  conv=lcase 2>/de
0f30: 76 2f 6e 75 6c 6c 29 22 0a 0a 09 63 61 73 65 20  v/null)"...case 
0f40: 22 24 7b 61 72 63 68 7d 22 20 69 6e 0a 09 09 69  "${arch}" in...i
0f50: 3f 38 36 29 0a 09 09 09 61 72 63 68 3d 27 69 78  ?86)....arch='ix
0f60: 38 36 27 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a  86'....;;..esac.
0f70: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74 65  }..function dete
0f80: 72 6d 69 6e 65 50 72 65 66 69 78 28 29 20 7b 0a  rminePrefix() {.
0f90: 09 64 65 74 65 72 6d 69 6e 65 4f 73 41 72 63 68  .determineOsArch
0fa0: 0a 0a 09 70 72 65 66 69 78 73 75 66 66 69 78 3d  ...prefixsuffix=
0fb0: 22 24 7b 70 6b 67 7d 2f 24 7b 6f 73 7d 2d 24 7b  "${pkg}/${os}-${
0fc0: 61 72 63 68 7d 2f 24 7b 76 65 72 73 69 6f 6e 7d  arch}/${version}
0fd0: 22 0a 09 70 72 65 66 69 78 3d 22 2f 6f 70 74 2f  "..prefix="/opt/
0fe0: 61 70 70 66 73 2f 24 7b 64 6f 6d 61 69 6e 7d 2f  appfs/${domain}/
0ff0: 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d 22  ${prefixsuffix}"
1000: 0a 09 64 65 73 74 64 69 72 3d 22 24 28 70 77 64  ..destdir="$(pwd
1010: 29 2f 49 4e 53 54 22 0a 0a 09 6d 6b 64 69 72 20  )/INST"...mkdir 
1020: 22 24 7b 64 65 73 74 64 69 72 7d 22 20 7c 7c 20  "${destdir}" || 
1030: 64 69 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20  die.}..function 
1040: 70 72 65 63 6f 6e 66 69 67 75 72 65 28 29 20 7b  preconfigure() {
1050: 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20  ..:.}..function 
1060: 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 28 29 20  postconfigure() 
1070: 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  {..:.}..function
1080: 20 63 6f 6e 66 69 67 75 72 65 5f 67 63 63 28 29   configure_gcc()
1090: 20 7b 0a 09 6c 6f 63 61 6c 20 67 6c 69 62 63 64   {..local glibcd
10a0: 69 72 20 6c 69 6e 75 78 68 65 61 64 65 72 73 64  ir linuxheadersd
10b0: 69 72 0a 09 6c 6f 63 61 6c 20 64 79 6e 6c 69 6e  ir..local dynlin
10c0: 6b 65 72 0a 09 6c 6f 63 61 6c 20 67 63 63 5f 64  ker..local gcc_d
10d0: 65 66 61 75 6c 74 5f 68 65 61 64 65 72 73 0a 0a  efault_headers..
10e0: 09 67 6c 69 62 63 64 69 72 3d 22 2f 6f 70 74 2f  .glibcdir="/opt/
10f0: 61 70 70 66 73 2f 63 6f 72 65 2e 61 70 70 66 73  appfs/core.appfs
1100: 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f 67 6c 69 62  .rkeene.org/glib
1110: 63 2f 70 6c 61 74 66 6f 72 6d 2f 6c 61 74 65 73  c/platform/lates
1120: 74 22 0a 09 67 6c 69 62 63 64 69 72 3d 22 24 28  t"..glibcdir="$(
1130: 72 65 61 64 6c 69 6e 6b 20 2d 66 20 22 24 7b 67  readlink -f "${g
1140: 6c 69 62 63 64 69 72 7d 22 29 22 0a 0a 09 6c 69  libcdir}")"...li
1150: 6e 75 78 68 65 61 64 65 72 73 64 69 72 3d 22 2f  nuxheadersdir="/
1160: 6f 70 74 2f 61 70 70 66 73 2f 63 6f 72 65 2e 61  opt/appfs/core.a
1170: 70 70 66 73 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f  ppfs.rkeene.org/
1180: 6c 69 6e 75 78 2d 68 65 61 64 65 72 73 2f 70 6c  linux-headers/pl
1190: 61 74 66 6f 72 6d 2f 6c 61 74 65 73 74 22 0a 09  atform/latest"..
11a0: 6c 69 6e 75 78 68 65 61 64 65 72 73 64 69 72 3d  linuxheadersdir=
11b0: 22 24 28 72 65 61 64 6c 69 6e 6b 20 2d 66 20 22  "$(readlink -f "
11c0: 24 7b 6c 69 6e 75 78 68 65 61 64 65 72 73 64 69  ${linuxheadersdi
11d0: 72 7d 22 29 22 0a 0a 09 64 79 6e 6c 69 6e 6b 65  r}")"...dynlinke
11e0: 72 3d 22 24 28 6c 73 20 22 24 7b 67 6c 69 62 63  r="$(ls "${glibc
11f0: 64 69 72 7d 22 2f 6c 69 62 2f 6c 64 2d 6c 69 6e  dir}"/lib/ld-lin
1200: 75 78 2a 2e 73 6f 2e 2a 20 7c 20 74 61 69 6c 20  ux*.so.* | tail 
1210: 2d 6e 20 31 29 22 0a 0a 09 69 66 20 5b 20 21 20  -n 1)"...if [ ! 
1220: 2d 66 20 22 24 7b 64 79 6e 6c 69 6e 6b 65 72 7d  -f "${dynlinker}
1230: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 64 69 65 20  " ]; then...die 
1240: 27 67 6c 69 62 63 20 64 69 72 65 63 74 6f 72 79  'glibc directory
1250: 20 69 73 20 6e 6f 74 20 61 76 61 69 6c 61 62 6c   is not availabl
1260: 65 20 28 61 70 70 66 73 20 72 75 6e 6e 69 6e 67  e (appfs running
1270: 2f 77 6f 72 6b 69 6e 67 3f 29 27 0a 09 66 69 0a  /working?)'..fi.
1280: 0a 09 67 63 63 5f 64 65 66 61 75 6c 74 5f 68 65  ..gcc_default_he
1290: 61 64 65 72 73 3d 22 24 28 65 63 68 6f 20 27 27  aders="$(echo ''
12a0: 20 7c 20 24 7b 43 50 50 3a 2d 63 70 70 7d 20 2d   | ${CPP:-cpp} -
12b0: 76 20 32 3e 26 31 20 7c 20 73 65 64 20 27 2f 5e  v 2>&1 | sed '/^
12c0: 45 6e 64 20 6f 66 20 73 65 61 72 63 68 20 6c 69  End of search li
12d0: 73 74 2f 2c 24 20 64 3b 30 2c 2f 73 65 61 72 63  st/,$ d;0,/searc
12e0: 68 20 73 74 61 72 74 73 20 68 65 72 65 3a 24 2f  h starts here:$/
12f0: 20 64 27 20 7c 20 67 72 65 70 20 27 2f 67 63 63   d' | grep '/gcc
1300: 2f 27 20 7c 20 73 65 64 20 27 73 40 5e 20 2a 40  /' | sed 's@^ *@
1310: 2d 69 73 79 73 74 65 6d 20 40 27 20 7c 20 74 72  -isystem @' | tr
1320: 20 24 27 5c 6e 27 20 27 20 27 29 22 0a 0a 09 43   $'\n' ' ')"...C
1330: 43 3d 22 24 7b 43 43 3a 2d 67 63 63 7d 20 2d 6e  C="${CC:-gcc} -n
1340: 6f 73 74 64 69 6e 63 20 24 7b 67 63 63 5f 64 65  ostdinc ${gcc_de
1350: 66 61 75 6c 74 5f 68 65 61 64 65 72 73 7d 20 2d  fault_headers} -
1360: 69 73 79 73 74 65 6d 20 24 7b 67 6c 69 62 63 64  isystem ${glibcd
1370: 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 43 58  ir}/include"..CX
1380: 58 3d 22 24 7b 43 58 58 3a 2d 67 2b 2b 7d 20 2d  X="${CXX:-g++} -
1390: 6e 6f 73 74 64 69 6e 63 20 24 7b 67 63 63 5f 64  nostdinc ${gcc_d
13a0: 65 66 61 75 6c 74 5f 68 65 61 64 65 72 73 7d 20  efault_headers} 
13b0: 2d 69 73 79 73 74 65 6d 20 24 7b 67 6c 69 62 63  -isystem ${glibc
13c0: 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 0a 09  dir}/include"...
13d0: 69 66 20 21 20 65 63 68 6f 20 22 20 24 7b 72 65  if ! echo " ${re
13e0: 71 75 69 72 65 5b 2a 5d 7d 20 22 20 7c 20 67 72  quire[*]} " | gr
13f0: 65 70 20 27 20 6c 69 6e 75 78 2d 68 65 61 64 65  ep ' linux-heade
1400: 72 73 5b 2f 40 3a 20 5d 27 20 3e 2f 64 65 76 2f  rs[/@: ]' >/dev/
1410: 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 43 43 3d  null; then...CC=
1420: 22 24 7b 43 43 7d 20 2d 69 73 79 73 74 65 6d 20  "${CC} -isystem 
1430: 24 7b 6c 69 6e 75 78 68 65 61 64 65 72 73 64 69  ${linuxheadersdi
1440: 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 09 43 58  r}/include"...CX
1450: 58 3d 22 24 7b 43 58 58 7d 20 2d 69 73 79 73 74  X="${CXX} -isyst
1460: 65 6d 20 24 7b 6c 69 6e 75 78 68 65 61 64 65 72  em ${linuxheader
1470: 73 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09  sdir}/include"..
1480: 66 69 0a 0a 09 42 55 49 4c 44 5f 43 43 3d 22 24  fi...BUILD_CC="$
1490: 7b 43 43 7d 22 0a 09 48 4f 53 54 5f 43 43 3d 22  {CC}"..HOST_CC="
14a0: 24 7b 43 43 7d 22 0a 0a 09 4c 44 46 4c 41 47 53  ${CC}"...LDFLAGS
14b0: 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 2d 4c 24  ="${LDFLAGS} -L$
14c0: 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69 62 20 2d  {glibcdir}/lib -
14d0: 57 6c 2c 2d 72 70 61 74 68 2c 24 7b 67 6c 69 62  Wl,-rpath,${glib
14e0: 63 64 69 72 7d 2f 6c 69 62 20 2d 57 6c 2c 2d 2d  cdir}/lib -Wl,--
14f0: 64 79 6e 61 6d 69 63 2d 6c 69 6e 6b 65 72 2c 24  dynamic-linker,$
1500: 7b 64 79 6e 6c 69 6e 6b 65 72 7d 22 0a 09 69 66  {dynlinker}"..if
1510: 20 5b 20 2d 7a 20 22 24 7b 61 70 70 66 73 5f 62   [ -z "${appfs_b
1520: 75 69 6c 64 5f 6e 6f 5f 64 65 66 61 75 6c 74 5f  uild_no_default_
1530: 73 79 6d 76 65 72 7d 22 20 5d 3b 20 74 68 65 6e  symver}" ]; then
1540: 0a 09 09 4c 44 46 4c 41 47 53 3d 22 24 7b 4c 44  ...LDFLAGS="${LD
1550: 46 4c 41 47 53 7d 20 2d 57 6c 2c 2d 2d 64 65 66  FLAGS} -Wl,--def
1560: 61 75 6c 74 2d 73 79 6d 76 65 72 22 0a 09 66 69  ault-symver"..fi
1570: 0a 0a 09 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49  ...PKG_CONFIG_LI
1580: 42 44 49 52 3d 22 24 7b 67 6c 69 62 63 64 69 72  BDIR="${glibcdir
1590: 7d 2f 6c 69 62 2f 70 6b 67 63 6f 6e 66 69 67 22  }/lib/pkgconfig"
15a0: 0a 0a 09 65 78 70 6f 72 74 20 43 43 20 42 55 49  ...export CC BUI
15b0: 4c 44 5f 43 43 20 48 4f 53 54 5f 43 43 20 4c 44  LD_CC HOST_CC LD
15c0: 46 4c 41 47 53 20 50 4b 47 5f 43 4f 4e 46 49 47  FLAGS PKG_CONFIG
15d0: 5f 4c 49 42 44 49 52 0a 7d 0a 0a 66 75 6e 63 74  _LIBDIR.}..funct
15e0: 69 6f 6e 20 63 6f 6e 66 69 67 75 72 65 28 29 20  ion configure() 
15f0: 7b 0a 09 63 6f 6e 66 69 67 75 72 65 5f 67 63 63  {..configure_gcc
1600: 0a 09 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d  .../configure --
1610: 70 72 65 66 69 78 3d 22 24 7b 70 72 65 66 69 78  prefix="${prefix
1620: 7d 22 20 2d 2d 73 79 73 63 6f 6e 66 64 69 72 3d  }" --sysconfdir=
1630: 22 24 7b 70 72 65 66 69 78 7d 2f 65 74 63 22 20  "${prefix}/etc" 
1640: 2d 2d 6c 69 62 64 69 72 3d 22 24 7b 70 72 65 66  --libdir="${pref
1650: 69 78 7d 2f 6c 69 62 22 20 2d 2d 6c 6f 63 61 6c  ix}/lib" --local
1660: 73 74 61 74 65 64 69 72 3d 2f 76 61 72 20 22 24  statedir=/var "$
1670: 7b 63 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61  {configure_extra
1680: 5b 40 5d 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f  [@]}".}..functio
1690: 6e 20 70 72 65 62 75 69 6c 64 28 29 20 7b 0a 09  n prebuild() {..
16a0: 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f  :.}..function po
16b0: 73 74 62 75 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d  stbuild() {..:.}
16c0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64  ..function build
16d0: 28 29 20 7b 0a 09 67 72 65 70 20 22 44 45 53 54  () {..grep "DEST
16e0: 44 49 52 22 20 4d 61 6b 65 66 69 6c 65 20 3e 2f  DIR" Makefile >/
16f0: 64 65 76 2f 6e 75 6c 6c 20 7c 7c 20 64 69 65 20  dev/null || die 
1700: 22 44 6f 6e 27 74 20 6b 6e 6f 77 20 68 6f 77 20  "Don't know how 
1710: 74 6f 20 62 75 69 6c 64 20 74 68 69 73 20 73 6f  to build this so
1720: 66 74 77 61 72 65 22 0a 0a 09 6d 61 6b 65 20 22  ftware"...make "
1730: 24 7b 6d 61 6b 65 5f 65 78 74 72 61 5b 40 5d 7d  ${make_extra[@]}
1740: 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72  ".}..function pr
1750: 65 69 6e 73 74 61 6c 6c 28 29 20 7b 0a 09 3a 0a  einstall() {..:.
1760: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f 73 74  }..function post
1770: 69 6e 73 74 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d  install() {..:.}
1780: 0a 0a 66 75 6e 63 74 69 6f 6e 20 69 6e 73 74 61  ..function insta
1790: 6c 6c 28 29 20 7b 0a 09 6d 61 6b 65 20 69 6e 73  ll() {..make ins
17a0: 74 61 6c 6c 20 44 45 53 54 44 49 52 3d 22 24 7b  tall DESTDIR="${
17b0: 64 65 73 74 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e  destdir}".}..fun
17c0: 63 74 69 6f 6e 20 63 6c 65 61 6e 75 70 28 29 20  ction cleanup() 
17d0: 7b 0a 09 63 64 20 22 24 7b 77 6f 72 6b 64 69 72  {..cd "${workdir
17e0: 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 63 64  }" || exit 1..cd
17f0: 20 2e 2e 20 7c 7c 20 65 78 69 74 20 31 0a 09 72   .. || exit 1..r
1800: 6d 20 2d 72 66 20 22 24 7b 77 6f 72 6b 64 69 72  m -rf "${workdir
1810: 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64  }".}..function d
1820: 69 65 28 29 20 7b 0a 09 6c 6f 63 61 6c 20 6d 65  ie() {..local me
1830: 73 73 61 67 65 0a 0a 09 6d 65 73 73 61 67 65 3d  ssage...message=
1840: 22 24 31 22 0a 0a 09 69 66 20 5b 20 2d 6e 20 22  "$1"...if [ -n "
1850: 24 7b 6d 65 73 73 61 67 65 7d 22 20 5d 3b 20 74  ${message}" ]; t
1860: 68 65 6e 0a 09 09 65 63 68 6f 20 22 65 72 72 6f  hen...echo "erro
1870: 72 3a 20 24 7b 6d 65 73 73 61 67 65 7d 22 20 3e  r: ${message}" >
1880: 26 32 0a 09 66 69 0a 0a 09 65 78 69 74 20 31 0a  &2..fi...exit 1.
1890: 7d 0a 0a 73 63 72 69 70 74 64 69 72 3d 22 24 28  }..scriptdir="$(
18a0: 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24  cd "$(dirname "$
18b0: 28 77 68 69 63 68 20 22 24 30 22 29 22 29 22 20  (which "$0")")" 
18c0: 26 26 20 70 77 64 29 22 0a 69 66 20 5b 20 2d 7a  && pwd)".if [ -z
18d0: 20 22 24 7b 73 63 72 69 70 74 64 69 72 7d 22 20   "${scriptdir}" 
18e0: 5d 3b 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 55  ]; then..echo "U
18f0: 6e 61 62 6c 65 20 74 6f 20 6c 6f 63 61 74 65 20  nable to locate 
1900: 73 63 72 69 70 74 20 64 69 72 65 63 74 6f 72 79  script directory
1910: 22 20 3e 26 32 0a 0a 09 65 78 69 74 20 31 0a 66  " >&2...exit 1.f
1920: 69 0a 0a 63 64 20 22 24 7b 73 63 72 69 70 74 64  i..cd "${scriptd
1930: 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a  ir}" || exit 1..
1940: 69 66 20 5b 20 2d 66 20 27 62 75 69 6c 64 2e 63  if [ -f 'build.c
1950: 6f 6e 66 27 20 5d 3b 20 74 68 65 6e 0a 09 2e 20  onf' ]; then... 
1960: 27 62 75 69 6c 64 2e 63 6f 6e 66 27 0a 66 69 0a  'build.conf'.fi.
1970: 0a 69 66 20 5b 20 2d 64 20 22 70 6b 67 73 2f 24  .if [ -d "pkgs/$
1980: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
1990: 70 6b 67 64 69 72 3d 22 24 28 70 77 64 29 2f 70  pkgdir="$(pwd)/p
19a0: 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b 67  kgs/${pkg}"..pkg
19b0: 66 69 6c 65 3d 22 24 7b 70 6b 67 64 69 72 7d 2f  file="${pkgdir}/
19c0: 69 6e 66 6f 22 0a 65 6c 73 65 0a 09 70 6b 67 66  info".else..pkgf
19d0: 69 6c 65 3d 22 24 28 70 77 64 29 2f 70 6b 67 73  ile="$(pwd)/pkgs
19e0: 2f 24 7b 70 6b 67 7d 22 0a 09 70 6b 67 64 69 72  /${pkg}"..pkgdir
19f0: 3d 22 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 66 69  ="${pkgfile}".fi
1a00: 0a 0a 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70  ..if [ ! -e "${p
1a10: 6b 67 66 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e  kgfile}" ]; then
1a20: 0a 09 65 63 68 6f 20 22 49 6e 76 61 6c 69 64 20  ..echo "Invalid 
1a30: 70 61 63 6b 61 67 65 2e 22 20 3e 26 32 0a 0a 09  package." >&2...
1a40: 65 78 69 74 20 31 0a 66 69 0a 0a 70 6b 67 64 61  exit 1.fi..pkgda
1a50: 74 65 3d 22 24 28 66 6f 72 20 61 72 74 69 66 61  te="$(for artifa
1a60: 63 74 20 69 6e 20 24 28 66 69 6e 64 20 22 24 7b  ct in $(find "${
1a70: 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65 20 66  pkgdir}" -type f
1a80: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
1a90: 20 2d 6e 20 31 20 2d 30 20 66 6f 73 73 69 6c 20   -n 1 -0 fossil 
1aa0: 66 69 6e 66 6f 20 2d 2d 6c 69 6d 69 74 20 31 20  finfo --limit 1 
1ab0: 2d 2d 77 69 64 74 68 20 30 20 32 3e 2f 64 65 76  --width 0 2>/dev
1ac0: 2f 6e 75 6c 6c 20 7c 20 67 72 65 70 20 27 5e 5b  /null | grep '^[
1ad0: 30 2d 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d 5b 30  0-9][0-9][0-9][0
1ae0: 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d 2d 5b  -9]-[0-9][0-9]-[
1af0: 30 2d 39 5d 5b 30 2d 39 5d 20 27 20 7c 20 73 65  0-9][0-9] ' | se
1b00: 64 20 27 73 40 5e 5b 5e 20 5d 2a 20 5c 5b 40 40  d 's@^[^ ]* \[@@
1b10: 3b 73 40 5c 5d 2e 2a 40 40 27 20 7c 20 73 6f 72  ;s@\].*@@' | sor
1b20: 74 20 2d 75 29 3b 20 64 6f 20 66 6f 73 73 69 6c  t -u); do fossil
1b30: 20 69 6e 66 6f 20 22 24 7b 61 72 74 69 66 61 63   info "${artifac
1b40: 74 7d 22 20 7c 20 61 77 6b 20 27 2f 5e 75 75 69  t}" | awk '/^uui
1b50: 64 3a 2f 7b 20 70 72 69 6e 74 20 24 33 20 24 34  d:/{ print $3 $4
1b60: 20 7d 27 20 7c 20 73 65 64 20 27 73 40 5b 2d 3a   }' | sed 's@[-:
1b70: 5d 40 40 67 3b 73 40 2e 2e 24 40 5c 2e 26 40 27  ]@@g;s@..$@\.&@'
1b80: 3b 20 64 6f 6e 65 20 7c 20 73 6f 72 74 20 2d 6e  ; done | sort -n
1b90: 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 69   | tail -n 1)".i
1ba0: 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67 64 61 74  f [ -z "${pkgdat
1bb0: 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 70 6b 67  e}" ]; then..pkg
1bc0: 64 61 74 65 3d 22 24 28 66 69 6e 64 20 22 24 7b  date="$(find "${
1bd0: 70 6b 67 64 69 72 7d 22 20 2d 74 79 70 65 20 66  pkgdir}" -type f
1be0: 20 2d 70 72 69 6e 74 66 20 27 25 54 59 25 54 6d   -printf '%TY%Tm
1bf0: 25 54 64 25 54 48 25 54 4d 2e 25 54 53 5c 6e 27  %Td%TH%TM.%TS\n'
1c00: 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 20 63   2>/dev/null | c
1c10: 75 74 20 2d 66 20 31 2d 32 20 2d 64 20 27 2e 27  ut -f 1-2 -d '.'
1c20: 20 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74 61 69   | sort -n | tai
1c30: 6c 20 2d 6e 20 31 29 22 0a 66 69 0a 0a 2e 20 22  l -n 1)".fi... "
1c40: 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 0a 61 72 63  ${pkgfile}"..arc
1c50: 68 69 76 65 64 69 72 3d 22 24 28 70 77 64 29 2f  hivedir="$(pwd)/
1c60: 41 52 43 48 49 56 45 22 0a 77 6f 72 6b 64 69 72  ARCHIVE".workdir
1c70: 3d 22 77 6f 72 6b 64 69 72 2d 24 24 24 7b 52 41  ="workdir-$$${RA
1c80: 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b  NDOM}${RANDOM}${
1c90: 52 41 4e 44 4f 4d 7d 22 0a 70 6b 67 61 72 63 68  RANDOM}".pkgarch
1ca0: 69 76 65 3d 22 24 7b 61 72 63 68 69 76 65 64 69  ive="${archivedi
1cb0: 72 7d 2f 24 7b 70 6b 67 7d 2d 24 7b 76 65 72 73  r}/${pkg}-${vers
1cc0: 69 6f 6e 7d 22 0a 6d 6b 64 69 72 20 22 24 7b 61  ion}".mkdir "${a
1cd0: 72 63 68 69 76 65 64 69 72 7d 22 20 3e 2f 64 65  rchivedir}" >/de
1ce0: 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75  v/null 2>/dev/nu
1cf0: 6c 6c 0a 6d 6b 64 69 72 20 22 24 7b 77 6f 72 6b  ll.mkdir "${work
1d00: 64 69 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  dir}" || exit 1.
1d10: 63 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20  cd "${workdir}" 
1d20: 7c 7c 20 65 78 69 74 20 31 0a 77 6f 72 6b 64 69  || exit 1.workdi
1d30: 72 3d 22 24 28 70 77 64 29 22 0a 0a 23 20 44 6f  r="$(pwd)"..# Do
1d40: 77 6e 6c 6f 61 64 0a 64 6f 77 6e 6c 6f 61 64 0a  wnload.download.
1d50: 0a 23 20 45 78 74 72 61 63 74 0a 65 78 74 72 61  .# Extract.extra
1d60: 63 74 0a 0a 23 20 49 66 20 77 65 20 6a 75 73 74  ct..# If we just
1d70: 20 68 61 76 65 20 6f 6e 65 20 64 69 72 65 63 74   have one direct
1d80: 6f 72 79 2c 20 75 73 65 20 74 68 61 74 20 64 69  ory, use that di
1d90: 72 65 63 74 6f 72 79 0a 64 69 72 3d 22 24 28 65  rectory.dir="$(e
1da0: 63 68 6f 20 2a 29 22 0a 69 66 20 5b 20 2d 65 20  cho *)".if [ -e 
1db0: 22 24 7b 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e  "${dir}" ]; then
1dc0: 0a 09 6d 76 20 22 24 7b 64 69 72 7d 22 2f 2a 20  ..mv "${dir}"/* 
1dd0: 2e 0a 66 69 0a 0a 23 20 56 65 72 69 66 79 20 70  ..fi..# Verify p
1de0: 72 65 2d 72 65 71 75 69 73 69 74 65 73 20 61 72  re-requisites ar
1df0: 65 20 6d 65 74 0a 76 65 72 69 66 79 52 65 71 75  e met.verifyRequ
1e00: 69 72 65 64 50 61 63 6b 61 67 65 73 20 7c 7c 20  iredPackages || 
1e10: 64 69 65 20 27 52 65 71 75 69 72 65 64 20 70 61  die 'Required pa
1e20: 63 6b 61 67 65 73 20 6d 69 73 73 69 6e 67 27 0a  ckages missing'.
1e30: 76 65 72 69 66 79 50 72 65 72 65 71 75 69 73 69  verifyPrerequisi
1e40: 74 65 73 20 7c 7c 20 64 69 65 20 27 50 72 65 72  tes || die 'Prer
1e50: 65 71 75 69 73 69 74 69 65 73 20 66 61 69 6c 65  equisities faile
1e60: 64 27 0a 0a 23 20 53 74 61 72 74 20 6c 6f 67 67  d'..# Start logg
1e70: 69 6e 67 0a 73 65 74 20 2d 78 0a 0a 23 20 44 65  ing.set -x..# De
1e80: 74 65 72 6d 69 6e 65 20 70 72 6f 70 65 72 74 69  termine properti
1e90: 65 73 0a 64 65 74 65 72 6d 69 6e 65 50 72 65 66  es.determinePref
1ea0: 69 78 0a 0a 23 20 41 70 70 6c 79 20 70 61 74 63  ix..# Apply patc
1eb0: 68 65 73 0a 61 70 70 6c 79 5f 70 61 74 63 68 65  hes.apply_patche
1ec0: 73 0a 0a 23 20 53 74 61 72 74 20 74 68 65 20 62  s..# Start the b
1ed0: 75 69 6c 64 0a 70 72 65 63 6f 6e 66 69 67 75 72  uild.preconfigur
1ee0: 65 20 7c 7c 20 64 69 65 20 27 70 72 65 63 6f 6e  e || die 'precon
1ef0: 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 63  figure failed'.c
1f00: 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20  onfigure || die 
1f10: 27 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c 65  'configure faile
1f20: 64 27 0a 70 6f 73 74 63 6f 6e 66 69 67 75 72 65  d'.postconfigure
1f30: 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 63 6f 6e   || die 'postcon
1f40: 66 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 0a  figure failed'..
1f50: 70 72 65 62 75 69 6c 64 20 7c 7c 20 64 69 65 20  prebuild || die 
1f60: 27 70 72 65 62 75 69 6c 64 20 66 61 69 6c 65 64  'prebuild failed
1f70: 27 0a 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27  '.build || die '
1f80: 62 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 70 6f  build failed'.po
1f90: 73 74 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27  stbuild || die '
1fa0: 70 6f 73 74 62 75 69 6c 64 20 66 61 69 6c 65 64  postbuild failed
1fb0: 27 0a 0a 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c  '..preinstall ||
1fc0: 20 64 69 65 20 27 70 72 65 69 6e 73 74 61 6c 6c   die 'preinstall
1fd0: 20 66 61 69 6c 65 64 27 0a 69 6e 73 74 61 6c 6c   failed'.install
1fe0: 20 7c 7c 20 64 69 65 20 27 69 6e 73 74 61 6c 6c   || die 'install
1ff0: 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 69 6e 73   failed'.postins
2000: 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73  tall || die 'pos
2010: 74 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27  tinstall failed'
2020: 0a 0a 28 0a 09 63 61 73 65 20 22 24 7b 74 61 72  ..(..case "${tar
2030: 67 65 74 6d 6f 64 65 7d 22 20 69 6e 0a 09 09 69  getmode}" in...i
2040: 6e 73 74 61 6c 6c 29 0a 09 09 09 61 70 70 64 69  nstall)....appdi
2050: 72 3d 22 24 28 61 70 70 66 73 69 6e 73 74 61 6c  r="$(appfsinstal
2060: 6c 64 69 72 29 2f 24 7b 70 72 65 66 69 78 73 75  ldir)/${prefixsu
2070: 66 66 69 78 7d 22 0a 09 09 09 6d 6b 64 69 72 20  ffix}"....mkdir 
2080: 2d 70 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 0a  -p "${appdir}"..
2090: 09 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72  ...cd "${destdir
20a0: 7d 2f 24 7b 70 72 65 66 69 78 7d 22 20 7c 7c 20  }/${prefix}" || 
20b0: 65 78 69 74 20 31 0a 0a 09 09 09 63 70 20 2d 72  exit 1.....cp -r
20c0: 70 20 2a 20 22 24 7b 61 70 70 64 69 72 7d 22 0a  p * "${appdir}".
20d0: 09 09 09 66 69 6e 64 20 22 24 7b 61 70 70 64 69  ...find "${appdi
20e0: 72 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61  r}" -print0 | xa
20f0: 72 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 74 20  rgs -0 touch -t 
2100: 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09  "${pkgdate}"....
2110: 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22  find "${appdir}"
2120: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
2130: 20 2d 30 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20   -0 touch -m -t 
2140: 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09  "${pkgdate}"....
2150: 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22  find "${appdir}"
2160: 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73   -print0 | xargs
2170: 20 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74 20   -0 touch -a -t 
2180: 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09  "${pkgdate}"....
2190: 3b 3b 0a 09 09 61 72 63 68 69 76 65 29 0a 09 09  ;;...archive)...
21a0: 09 61 72 63 68 69 76 65 66 69 6c 65 3d 22 24 7b  .archivefile="${
21b0: 73 63 72 69 70 74 64 69 72 7d 2f 24 7b 70 6b 67  scriptdir}/${pkg
21c0: 7d 2d 24 7b 76 65 72 73 69 6f 6e 7d 2d 24 28 65  }-${version}-$(e
21d0: 63 68 6f 20 22 24 7b 70 6b 67 64 61 74 65 7d 22  cho "${pkgdate}"
21e0: 20 7c 20 73 65 64 20 27 73 40 5c 2e 40 40 67 27   | sed 's@\.@@g'
21f0: 29 2d 24 7b 6f 73 7d 2d 24 7b 61 72 63 68 7d 2d  )-${os}-${arch}-
2200: 24 7b 64 6f 6d 61 69 6e 7d 2e 63 70 69 6f 22 0a  ${domain}.cpio".
2210: 09 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72  ...cd "${destdir
2220: 7d 2f 24 7b 70 72 65 66 69 78 7d 2f 2e 2e 2f 2e  }/${prefix}/../.
2230: 2e 2f 2e 2e 22 20 7c 7c 20 65 78 69 74 20 31 0a  ./.." || exit 1.
2240: 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69  ...find "${prefi
2250: 78 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e 74  xsuffix}" -print
2260: 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75  0 | xargs -0 tou
2270: 63 68 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65  ch -t "${pkgdate
2280: 7d 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72  }"....find "${pr
2290: 65 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72  efixsuffix}" -pr
22a0: 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20  int0 | xargs -0 
22b0: 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70  touch -m -t "${p
22c0: 6b 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64  kgdate}"....find
22d0: 20 22 24 7b 70 72 65 66 69 78 73 75 66 66 69 78   "${prefixsuffix
22e0: 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72  }" -print0 | xar
22f0: 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d  gs -0 touch -a -
2300: 74 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09  t "${pkgdate}"..
2310: 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78  ..find "${prefix
2320: 73 75 66 66 69 78 7d 22 20 7c 20 73 6f 72 74 20  suffix}" | sort 
2330: 7c 20 63 70 69 6f 20 2d 2d 6f 77 6e 65 72 20 30  | cpio --owner 0
2340: 3a 30 20 2d 48 20 6e 65 77 63 20 2d 6f 20 3e 20  :0 -H newc -o > 
2350: 22 24 7b 61 72 63 68 69 76 65 66 69 6c 65 7d 22  "${archivefile}"
2360: 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 29 20 7c  ....;;..esac.) |
2370: 7c 20 64 69 65 20 27 66 69 6e 61 6c 20 69 6e 73  | die 'final ins
2380: 74 61 6c 6c 61 74 69 6f 6e 20 66 61 69 6c 65 64  tallation failed
2390: 27 0a 0a 63 6c 65 61 6e 75 70 0a 0a 65 78 69 74  '..cleanup..exit
23a0: 20 30 0a                                          0.